#include <windows.h>
#include <process.h>
#include <stdio.h>
#include <conio.h>

#include "tiny_wii_bt.h"
#include "tiny_hid_dll.h"

HANDLE hRsDevHandle;
const USHORT VID = 0x057e; // Nintendo
const USHORT PID = 0x0306; // Wii-Remote

#define MAXREPORTSIZE 256
int		InputLength,OutputLength;
unsigned char	InputReport[MAXREPORTSIZE];
unsigned char	OutputReport[MAXREPORTSIZE];
unsigned char	wii_remote_loop_flag;
unsigned char	wii_remote_in_use;
int Ax,Ay,Az,button1,button2;
uintptr_t wii_th;


void _more(void)
{
	printf("[L[ĉ]\n"); getch();
}

void Report_0x11(unsigned char data)
{
	OutputReport[0]=0x11; // Report ID
	OutputReport[1]=data;
	WriteReport( hRsDevHandle , OutputReport , &OutputLength);
}

void Report_0x12(unsigned char data1,unsigned char data2)
{
	OutputReport[0]=0x12; // Report ID
	OutputReport[1]=data1;
	OutputReport[2]=data2;
	WriteReport( hRsDevHandle , OutputReport , &OutputLength);
}

void Report_0x13(unsigned char data)
{
	OutputReport[0]=0x13; // Report ID
	OutputReport[1]=data;
	WriteReport( hRsDevHandle , OutputReport , &OutputLength);
}

void Wii_Remote_mode_0x31(void)
{
	// Set Report Type
	Report_0x12(0x00,0x31);  // Acc Sensor + button  Report Mode
}

void Wii_Remote_Input(void)
{
	ReadReport( hRsDevHandle , InputReport, &InputLength);
	if ( InputReport[0]==0x30 ) {
		button1=InputReport[1]; button2=InputReport[2];
	} else if ( InputReport[0]==0x31 ) {
		button1=InputReport[1]; button2=InputReport[2];
		Ax = InputReport[3]; Ay = InputReport[4]; Az = InputReport[5];
	}
}

void Wii_Remote_Input_Main(void *)
{
	// wii remote input thread
	while (wii_remote_loop_flag) {
		wii_remote_in_use=1;
		Wii_Remote_Input();
		Sleep(100);
	}
	wii_remote_in_use=0;
	return;
}

int Wii_Remote_check(void)
{
	Ax=0;
	wii_remote_loop_flag=1;
	wii_th = _beginthread( Wii_Remote_Input_Main , 0 , NULL );
	Sleep(1000);
	wii_remote_loop_flag=0;
	return (Ax!=0);
}

void Stop_Wii_remote_th(void)
{
	if (wii_remote_in_use==1) {
		TerminateThread( (HANDLE)wii_th , -1); // kill thread  if it stopped
	}
}


int main()
{
	int r;
	
	printf("###########################################\n");
	printf("#                                         #\n");
	printf("#   Wii-Remote Connect Test version 0.1   #\n");
	printf("#                  build 2009.6.21        #\n");
	printf("#                                         #\n");
	printf("###########################################\n");
	printf("\n");
	
	// BluetoothC^[tF[X(e@)T
	r = TinyBT_check_parent();
	if (r==0) {
		printf("BluetoothC^[tF[X(e@)܂\n");
		_more(); exit(1);
	}
	
	// WiiRɐڑς݂ǂ`FbN
	r = TinyBT_check_wii_remote_connected();
	if (r==1) {
		printf("ɐڑς݂łB\n");
		printf("\n");
		printf("WiiR̐ڑ܂B\n");
		printf("foCX폜\n");
		printf(".\n");
		TinyBT_close_wii_remote();
		printf("foCX폜܂B\n");
		printf("I܂B\n");
		_more(); exit(1);
	}
	
	printf("WiiR܂BWiiR1{^2{^ĉB\n");
	printf("\n");
	
	// ȑOɐڑ̏폜
	TinyBT_clear_remembered_wii_remote();
	
	for (int n=0;n<10;n++) {
		printf(".");
		r =TinyBT_search_wii_remote(); // WiiR
		if (r==1) { break; }
	}
	printf("\n");
	
	if (r==1) {
		printf("WiiR𔭌܂B\n");
		printf("HIDT[rXN܂B(T[rXNɐb܂)\n");
		TinyBT_start_wii_remote_hid_service();
		printf("."); Sleep(2000);
		printf("."); Sleep(1000);
		printf("\n");
	} else {
		printf("WiiR܂łB\n");
		TinyBT_finish();
		_more(); exit(1);
	}
	TinyBT_finish();
	
	printf("WiiRHIDI[v܂B\n");
	r=0;
	while (1) {
		printf(".");
		hRsDevHandle = OpenHidHandle(VID,PID);
		if ( hRsDevHandle != INVALID_HANDLE_VALUE) { break; }
		r++;
		if (r>10) {
			printf("\n"); printf("WiiRHIDJ܂B\n");
			_more(); exit(1);
		}
		Sleep(500);
	}
	printf("\n");
	
	Wii_Remote_mode_0x31();
	if ( Wii_Remote_check() ) {
		printf("WiiRLED_܂B\n");
		Report_0x13(0x01);  //Rumble ON
		Sleep(100); // wait
		Report_0x13(0x00); //Rumble OFF
		Report_0x11(0x10); // LED1 on
	} else {
		printf("WiiR̉܂B\n");
		Stop_Wii_remote_th();
		CloseHidHandle( hRsDevHandle );
		_more(); exit(1);
	}
	Stop_Wii_remote_th();
	CloseHidHandle( hRsDevHandle );
	printf("WiiRڑ܂B\n");
	_more();
	return 0;
}
